package moneymoney

import "time"

type Stock struct {
	// 日期
	Date time.Time `json:"日期" bson:"日期"`
	// 股票代码
	CodeStr string `json:"股票代码" bson:"股票代码"`
	// 名称
	Name string `json:"名称" bson:"名称"`
	// 收盘价
	ClosingPrice float64 `json:"收盘价" bson:"收盘价"`
	// 最高价
	MaxPrice float64 `json:"最高价" bson:"最高价"`
	// 最低价
	MinPrice float64 `json:"最低价" bson:"最低价"`
	// 开盘价
	OpeningPrice float64 `json:"开盘价" bson:"开盘价"`
	// 前收盘
	PreviousClosingPrice float64 `json:"前收盘" bson:"前收盘"`
	// 涨跌额
	UpsDowns float64 `json:"涨跌额" bson:"涨跌额"`
	// 涨跌幅
	UpsDownsRatio float64 `json:"涨跌幅" bson:"涨跌幅"`
	// 换手率
	TurnoverRate float64 `json:"换手率" bson:"换手率"`
	// 成交量
	Volume float64 `json:"成交量" bson:"成交量"`
	// 成交金额
	Turnover float64 `json:"成交金额" bson:"成交金额"`
	// 总市值
	MarketValue float64 `json:"总市值" bson:"总市值"`
	// 流通市值
	CirculatingMarketValue float64 `json:"流通市值" bson:"流通市值"`
	// 股票数字代码
	Code int64 `json:"股票数字代码" bson:"股票数字代码"`

	Extend *StockExtend `json:"Extend" bson:"Extend"`
}

type StockExtend struct {
	UpsDownsRatioDays []float64 `json:"UpsDownsRatioDays" bson:"UpsDownsRatioDays"`
	MaxPriceDays      float64   `json:"MaxPriceDays" bson:"MaxPriceDays"`
	MinPriceDay       float64   `json:"MinPriceDay" bson:"MinPriceDay"`
}

type StockBase struct {
	// CodeStr string // 代地区码
	// Code    string // 不带地区码

	CODE        string  `json:"CODE"`
	FIVE_MINUTE float64 `json:"FIVE_MINUTE"`
	HIGH        float64 `json:"HIGH"`
	HS          float64 `json:"HS"`
	LB          float64 `json:"LB"`
	LOW         float64 `json:"LOW"`
	MCAP        float64 `json:"MCAP"`
	MFSUM       float64 `json:"MFSUM"`
	NAME        string  `json:"NAME"`
	OPEN        float64 `json:"OPEN"`
	PE          float64 `json:"PE"`
	PERCENT     float64 `json:"PERCENT"`
	PRICE       float64 `json:"PRICE"`
	SNAME       string  `json:"SNAME"`
	SYMBOL      string  `json:"SYMBOL"`
	TCAP        float64 `json:"TCAP"`
	TURNOVER    float64 `json:"TURNOVER"`
	UPDOWN      float64 `json:"UPDOWN"`
	VOLUME      float64 `json:"VOLUME"`
	WB          float64 `json:"WB"`
	YESTCLOSE   float64 `json:"YESTCLOSE"`
	ZF          float64 `json:"ZF"`
	NO          float64 `json:"NO"`
}
